.TH "ORPIN-CLI" "1" "August 2019" "" ""
.SH "NAME"
\fBorpin-cli\fR
.SH "DESCRIPTION"
.P
orpin helps to manage npm packages in your web projects by keeping your the \fB<script>\fR tags within your \fB<head></head>\fR element in sync with the versions in your package.json file. Currently orpin only supports jsdelivr for fetching any packages and as the url in the \fBsrc\fR attribute for the injected script tag.
.SH "SYNOPSIS"
.P
\fBorpin\fR \fB\[lB]<flags>\[rB]\fR
.SH "CONFIGURATION"
.P
orpin can be configured either via a config file \fB.orpinrc\fR or from flags passed to the cli.
.P
orpin also depends on a file called \fBpackage.json\fR to know which version of files to get from the cdn. The \fBpackage.json\fR file should be located in the same directory as \fB.orpinrc\fR. The \fBpacakge.json\fR should have a key \fBdependencies\fR which is an object whose keys match the keys in \fBpackages\fR within \fB.orpinrc\fR and the value is the semver compatible version number to use.
.SS ".orpinrc"
.P
The following are the accepted values for an `.orpinrc.
.SS "anchorSelector"
.P
A valid dom selector to some element in the \fBindexFile\fR which tells orpin where to inject the script tags for the \fBpackages\fR. orpin always injects before the \fBanchorSelector\fR.
.SS "indexFile"
.P
A path to an html file where the script tags for the \fBpackages\fR will be injected.
.SS "packages"
.P
Each packages represents an npm package to download from cdnjs. Each package can specify three options \fBpath\fR and \fBdevPath\fR is where to find the file you want from the cdn; the url looks like:
.P
\fBhttps://cdn.jsdelivr.net/npm/package@version/file\fR
.P
The \fBdevPath\fR takes precedency over \fBpath\fR when it has been supplied a value and the environment variable \fBPRODUCTION\fR is not set. This is useful for when npm packges have production and development versions you would like to use (e.g React):
.P
.RS 2
.nf
{
    "packages": {
        "devPath": "umd/react.development.js",
        "path": "umd/react.production.js"
    }
}
.fi
.RE
.SS "vendorPath"
.P
A path to a directory where downloaded files will saved.
.P
orpin will create the \fBvendorPath\fR if is does not already exist but will throw an error if the path exists and the current user does not have read and write permissions
.SS "vendorSrcPrefix"
.P
A string representing what the \fBsrc\fR attribute will be for the script tags injected into \fBindexFile\fR

\(em\(em\(em
.P
A typical \fB.orpinrc\fR looks like: 
.P
.RS 2
.nf
{
  "anchorSelector": "script\[lB]src='js/something.js'\[rB]",
  "indexFile": "public/index.html",
  "vendorPath": "public/assets/vendor",
  "vendorSrcPrefix": "assets/vendor",
  "packages": {
    "dompurify": {
      "path": "dist/purify.js"
    },
    "localforage": {
      "devPath": "dist/localforage.js",
      "path": "dist/localforage.min.js"
    },
    "lodash.debounce": {
      "skip": true
    }
  }
}
.fi
.RE
.SS "CLI Parameters"
.P
The cli help page list all parameters and can be accessed with the -h flag.
.P
.RS 2
.nf
➜ ./bin/cli.js --help

Usage:

    cli.js \[lB]<options>\[rB]

Options:
  -c, --config_path  Path to .orpinrc
  -d, --defer_off    Exclude 'defer' attribute from tags
  -k, --check        Check if orpin can be run
  -f, --force        Fetch remote files
  -h, --help         Show help
  -v, --version      Show version number

for more information, checkout https://gitlab.com/vaemoi/orpin/orpin-cli
.fi
.RE
.SH "EXAMPLES"
.SS "cli usage"
.RS 0
.IP \(bu 4
Normal
.RE 0

.P
.RS 2
.nf
orpin
.fi
.RE
.RS 0
.IP \(bu 4
Passing the path to a config file
.RE 0

.P
.RS 2
.nf
orpin -c ../some/path/to/.orpinrc
.fi
.RE
.RS 0
.IP \(bu 4
Turning off defer and forcing download
.RE 0

.P
.RS 2
.nf
orpin -d --force
.fi
.RE
.RS 0
.IP \(bu 4
Prodcution (fetching files and injecting but not saving the file)
.RE 0

.P
.RS 2
.nf
export PRODUCTION=true && orpin
.fi
.RE
.SS "usage in NodeJS"
.P
(Coming soon)
